/* build rxast warpin file */
Trace 'N'
rxast_lvl = '191'
rxast_patch = '1'

Call Rxfuncadd 'SysLoadFuncs','Rexxutil','SysLoadFuncs'
Call SysLoadFuncs

Parse Source . . our_prog .
our_dir = Strip(Filespec('d', our_prog)||Filespec('p', our_prog), 't', '\')
Call Directory our_dir

os2env = 'os2environment'
our_list = our_dir||'\rxast'||rxast_lvl||'.lst'
our_input = SysTempFileName(Value('tmp', , os2env)||'\rx???ast')
Call SysMkDir our_input

/* copy the source to the input */
Do While Lines(our_list)
   line = Linein(our_list)
   If Abbrev(line, ';') | line = '' Then
      Iterate
   Parse Var line action parms
   action = Translate(action)
   Select
      When action = 'PACKVXRX' Then Do
         Parse Var parms source .
         Address cmd 'packvxrx' Get_path(source)
      End
      When action = 'LXLITE' Then Do
         Parse Var parms source .
         Address cmd 'lxlite' Get_path(source)
      End
      When action = 'ZIP' Then Do
         Parse Var parms source options target
         Address cmd 'zip' options Get_path(target) Get_path(source)
      End
      When action = 'COPY' Then Do
         Parse Var parms source target .
         Address cmd 'copy' Get_path(source) Get_path(target) '>> nul'
      End
      Otherwise
         Nop
   End
End

/* build rxast install file */
rxast_wis = our_dir||'\rxast'||rxast_lvl||rxast_patch||'.wis'
rxast_exe = our_dir||'\rxast'||rxast_lvl||rxast_patch||'.exe'
wic_dir = Strip(SysIni('user', 'WarpIN', 'Path'), 't', '00'x)
If wic_dir = 'ERROR:' Then Do
   Say 'Unable to locate WarpIN directory'
   Return 1
End
wic_exe = wic_dir||'\wic.exe'
stub_exe = wic_dir||'\stub.exe'
Call SysFileDelete rxast_exe
Call Directory wic_dir
Address cmd '@'||wic_exe rxast_exe ,
   '-a 1 -c'||our_input '*' ,
   '-u'||stub_exe '-s' rxast_wis
xrc = rc
Call Directory our_dir
If xrc = 0 Then
   Say rxast_exe 'built'
Else Do
   Say rxast_exe 'build failed'
   Return xrc
End
/* clean out the input area */
If SysFileTree(our_input||'\*', 'files.', 'fo') = 0 Then Do x = 1 To files.0
   Call SysFileDelete files.x
End
Call SysRmDir our_input
Return xrc

Get_path:
Procedure Expose our_dir our_input
Parse Arg path, .
Select
   When Abbrev(path, '.\') Then
      path = our_dir||Substr(path, 2)
   When Abbrev(path, '..\') Then
      path = Filespec('d', our_dir)||Filespec('p', our_dir)||Substr(path, 3)
   When path = '' Then
      path = our_input
   Otherwise
      Nop
End
Return path